# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities

__all__ = ['ScalingConfigurationAttachmentArgs', 'ScalingConfigurationAttachment']

@pulumi.input_type
class ScalingConfigurationAttachmentArgs:
    def __init__(__self__, *,
                 scaling_configuration_id: pulumi.Input[str]):
        """
        The set of arguments for constructing a ScalingConfigurationAttachment resource.
        :param pulumi.Input[str] scaling_configuration_id: The id of the scaling configuration.
        """
        pulumi.set(__self__, "scaling_configuration_id", scaling_configuration_id)

    @property
    @pulumi.getter(name="scalingConfigurationId")
    def scaling_configuration_id(self) -> pulumi.Input[str]:
        """
        The id of the scaling configuration.
        """
        return pulumi.get(self, "scaling_configuration_id")

    @scaling_configuration_id.setter
    def scaling_configuration_id(self, value: pulumi.Input[str]):
        pulumi.set(self, "scaling_configuration_id", value)


@pulumi.input_type
class _ScalingConfigurationAttachmentState:
    def __init__(__self__, *,
                 scaling_configuration_id: Optional[pulumi.Input[str]] = None):
        """
        Input properties used for looking up and filtering ScalingConfigurationAttachment resources.
        :param pulumi.Input[str] scaling_configuration_id: The id of the scaling configuration.
        """
        if scaling_configuration_id is not None:
            pulumi.set(__self__, "scaling_configuration_id", scaling_configuration_id)

    @property
    @pulumi.getter(name="scalingConfigurationId")
    def scaling_configuration_id(self) -> Optional[pulumi.Input[str]]:
        """
        The id of the scaling configuration.
        """
        return pulumi.get(self, "scaling_configuration_id")

    @scaling_configuration_id.setter
    def scaling_configuration_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "scaling_configuration_id", value)


class ScalingConfigurationAttachment(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 scaling_configuration_id: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        """
        Provides a resource to manage scaling configuration attachment
        ## Example Usage

        ```python
        import pulumi
        import pulumi_volcengine as volcengine

        foo_zones = volcengine.ecs.zones()
        foo_vpc = volcengine.vpc.Vpc("fooVpc",
            vpc_name="acc-test-vpc",
            cidr_block="172.16.0.0/16")
        foo_subnet = volcengine.vpc.Subnet("fooSubnet",
            subnet_name="acc-test-subnet",
            cidr_block="172.16.0.0/24",
            zone_id=foo_zones.zones[0].id,
            vpc_id=foo_vpc.id)
        foo_security_group = volcengine.vpc.SecurityGroup("fooSecurityGroup",
            security_group_name="acc-test-security-group",
            vpc_id=foo_vpc.id)
        foo_images = volcengine.ecs.images(os_type="Linux",
            visibility="public",
            instance_type_id="ecs.g1.large")
        foo_scaling_group = volcengine.autoscaling.ScalingGroup("fooScalingGroup",
            scaling_group_name="acc-test-scaling-group",
            subnet_ids=[foo_subnet.id],
            multi_az_policy="BALANCE",
            desire_instance_number=0,
            min_instance_number=0,
            max_instance_number=1,
            instance_terminate_policy="OldestInstance",
            default_cooldown=10)
        foo_scaling_configuration = volcengine.autoscaling.ScalingConfiguration("fooScalingConfiguration",
            image_id=foo_images.images[0].image_id,
            instance_name="acc-test-instance",
            instance_types=["ecs.g1.large"],
            password="93f0cb0614Aab12",
            scaling_configuration_name="acc-test-scaling-config",
            scaling_group_id=foo_scaling_group.id,
            security_group_ids=[foo_security_group.id],
            volumes=[volcengine.autoscaling.ScalingConfigurationVolumeArgs(
                volume_type="ESSD_PL0",
                size=50,
                delete_with_instance=True,
            )])
        foo_scaling_configuration_attachment = volcengine.autoscaling.ScalingConfigurationAttachment("fooScalingConfigurationAttachment", scaling_configuration_id=foo_scaling_configuration.id)
        ```

        ## Import

        Scaling Configuration attachment can be imported using the scaling_configuration_id e.g.
        The launch template and scaling configuration cannot take effect at the same time.

        ```sh
        $ pulumi import volcengine:autoscaling/scalingConfigurationAttachment:ScalingConfigurationAttachment default enable:scc-ybrurj4uw6gh9zecj327
        ```

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] scaling_configuration_id: The id of the scaling configuration.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: ScalingConfigurationAttachmentArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Provides a resource to manage scaling configuration attachment
        ## Example Usage

        ```python
        import pulumi
        import pulumi_volcengine as volcengine

        foo_zones = volcengine.ecs.zones()
        foo_vpc = volcengine.vpc.Vpc("fooVpc",
            vpc_name="acc-test-vpc",
            cidr_block="172.16.0.0/16")
        foo_subnet = volcengine.vpc.Subnet("fooSubnet",
            subnet_name="acc-test-subnet",
            cidr_block="172.16.0.0/24",
            zone_id=foo_zones.zones[0].id,
            vpc_id=foo_vpc.id)
        foo_security_group = volcengine.vpc.SecurityGroup("fooSecurityGroup",
            security_group_name="acc-test-security-group",
            vpc_id=foo_vpc.id)
        foo_images = volcengine.ecs.images(os_type="Linux",
            visibility="public",
            instance_type_id="ecs.g1.large")
        foo_scaling_group = volcengine.autoscaling.ScalingGroup("fooScalingGroup",
            scaling_group_name="acc-test-scaling-group",
            subnet_ids=[foo_subnet.id],
            multi_az_policy="BALANCE",
            desire_instance_number=0,
            min_instance_number=0,
            max_instance_number=1,
            instance_terminate_policy="OldestInstance",
            default_cooldown=10)
        foo_scaling_configuration = volcengine.autoscaling.ScalingConfiguration("fooScalingConfiguration",
            image_id=foo_images.images[0].image_id,
            instance_name="acc-test-instance",
            instance_types=["ecs.g1.large"],
            password="93f0cb0614Aab12",
            scaling_configuration_name="acc-test-scaling-config",
            scaling_group_id=foo_scaling_group.id,
            security_group_ids=[foo_security_group.id],
            volumes=[volcengine.autoscaling.ScalingConfigurationVolumeArgs(
                volume_type="ESSD_PL0",
                size=50,
                delete_with_instance=True,
            )])
        foo_scaling_configuration_attachment = volcengine.autoscaling.ScalingConfigurationAttachment("fooScalingConfigurationAttachment", scaling_configuration_id=foo_scaling_configuration.id)
        ```

        ## Import

        Scaling Configuration attachment can be imported using the scaling_configuration_id e.g.
        The launch template and scaling configuration cannot take effect at the same time.

        ```sh
        $ pulumi import volcengine:autoscaling/scalingConfigurationAttachment:ScalingConfigurationAttachment default enable:scc-ybrurj4uw6gh9zecj327
        ```

        :param str resource_name: The name of the resource.
        :param ScalingConfigurationAttachmentArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(ScalingConfigurationAttachmentArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 scaling_configuration_id: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = ScalingConfigurationAttachmentArgs.__new__(ScalingConfigurationAttachmentArgs)

            if scaling_configuration_id is None and not opts.urn:
                raise TypeError("Missing required property 'scaling_configuration_id'")
            __props__.__dict__["scaling_configuration_id"] = scaling_configuration_id
        super(ScalingConfigurationAttachment, __self__).__init__(
            'volcengine:autoscaling/scalingConfigurationAttachment:ScalingConfigurationAttachment',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            scaling_configuration_id: Optional[pulumi.Input[str]] = None) -> 'ScalingConfigurationAttachment':
        """
        Get an existing ScalingConfigurationAttachment resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] scaling_configuration_id: The id of the scaling configuration.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _ScalingConfigurationAttachmentState.__new__(_ScalingConfigurationAttachmentState)

        __props__.__dict__["scaling_configuration_id"] = scaling_configuration_id
        return ScalingConfigurationAttachment(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="scalingConfigurationId")
    def scaling_configuration_id(self) -> pulumi.Output[str]:
        """
        The id of the scaling configuration.
        """
        return pulumi.get(self, "scaling_configuration_id")

