# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from . import outputs

__all__ = [
    'PermissionSetAssignmentsResult',
    'AwaitablePermissionSetAssignmentsResult',
    'permission_set_assignments',
    'permission_set_assignments_output',
]

@pulumi.output_type
class PermissionSetAssignmentsResult:
    """
    A collection of values returned by PermissionSetAssignments.
    """
    def __init__(__self__, assignments=None, id=None, name_regex=None, output_file=None, permission_set_id=None, principal_id=None, principal_type=None, target_id=None, total_count=None):
        if assignments and not isinstance(assignments, list):
            raise TypeError("Expected argument 'assignments' to be a list")
        pulumi.set(__self__, "assignments", assignments)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if name_regex and not isinstance(name_regex, str):
            raise TypeError("Expected argument 'name_regex' to be a str")
        pulumi.set(__self__, "name_regex", name_regex)
        if output_file and not isinstance(output_file, str):
            raise TypeError("Expected argument 'output_file' to be a str")
        pulumi.set(__self__, "output_file", output_file)
        if permission_set_id and not isinstance(permission_set_id, str):
            raise TypeError("Expected argument 'permission_set_id' to be a str")
        pulumi.set(__self__, "permission_set_id", permission_set_id)
        if principal_id and not isinstance(principal_id, str):
            raise TypeError("Expected argument 'principal_id' to be a str")
        pulumi.set(__self__, "principal_id", principal_id)
        if principal_type and not isinstance(principal_type, str):
            raise TypeError("Expected argument 'principal_type' to be a str")
        pulumi.set(__self__, "principal_type", principal_type)
        if target_id and not isinstance(target_id, str):
            raise TypeError("Expected argument 'target_id' to be a str")
        pulumi.set(__self__, "target_id", target_id)
        if total_count and not isinstance(total_count, int):
            raise TypeError("Expected argument 'total_count' to be a int")
        pulumi.set(__self__, "total_count", total_count)

    @property
    @pulumi.getter
    def assignments(self) -> Sequence['outputs.PermissionSetAssignmentsAssignmentResult']:
        """
        The collection of query.
        """
        return pulumi.get(self, "assignments")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="nameRegex")
    def name_regex(self) -> Optional[str]:
        return pulumi.get(self, "name_regex")

    @property
    @pulumi.getter(name="outputFile")
    def output_file(self) -> Optional[str]:
        return pulumi.get(self, "output_file")

    @property
    @pulumi.getter(name="permissionSetId")
    def permission_set_id(self) -> Optional[str]:
        """
        The id of the cloud identity permission set.
        """
        return pulumi.get(self, "permission_set_id")

    @property
    @pulumi.getter(name="principalId")
    def principal_id(self) -> Optional[str]:
        """
        The principal id of the cloud identity permission set assignment.
        """
        return pulumi.get(self, "principal_id")

    @property
    @pulumi.getter(name="principalType")
    def principal_type(self) -> Optional[str]:
        """
        The principal type of the cloud identity permission set assignment.
        """
        return pulumi.get(self, "principal_type")

    @property
    @pulumi.getter(name="targetId")
    def target_id(self) -> Optional[str]:
        """
        The target account id of the cloud identity permission set assignment.
        """
        return pulumi.get(self, "target_id")

    @property
    @pulumi.getter(name="totalCount")
    def total_count(self) -> int:
        """
        The total count of query.
        """
        return pulumi.get(self, "total_count")


class AwaitablePermissionSetAssignmentsResult(PermissionSetAssignmentsResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return PermissionSetAssignmentsResult(
            assignments=self.assignments,
            id=self.id,
            name_regex=self.name_regex,
            output_file=self.output_file,
            permission_set_id=self.permission_set_id,
            principal_id=self.principal_id,
            principal_type=self.principal_type,
            target_id=self.target_id,
            total_count=self.total_count)


def permission_set_assignments(name_regex: Optional[str] = None,
                               output_file: Optional[str] = None,
                               permission_set_id: Optional[str] = None,
                               principal_id: Optional[str] = None,
                               principal_type: Optional[str] = None,
                               target_id: Optional[str] = None,
                               opts: Optional[pulumi.InvokeOptions] = None) -> AwaitablePermissionSetAssignmentsResult:
    """
    Use this data source to query detailed information of cloud identity permission set assignments
    ## Example Usage

    ```python
    import pulumi
    import pulumi_volcengine as volcengine

    foo_permission_set = volcengine.cloud_identity.PermissionSet("fooPermissionSet",
        description="tf",
        session_duration=5000,
        permission_policies=[
            volcengine.cloud_identity.PermissionSetPermissionPolicyArgs(
                permission_policy_type="System",
                permission_policy_name="AdministratorAccess",
                inline_policy_document="",
            ),
            volcengine.cloud_identity.PermissionSetPermissionPolicyArgs(
                permission_policy_type="System",
                permission_policy_name="ReadOnlyAccess",
                inline_policy_document="",
            ),
            volcengine.cloud_identity.PermissionSetPermissionPolicyArgs(
                permission_policy_type="Inline",
                inline_policy_document="{\\"Statement\\":[{\\"Effect\\":\\"Allow\\",\\"Action\\":[\\"auto_scaling:DescribeScalingGroups\\"],\\"Resource\\":[\\"*\\"]}]}",
            ),
        ])
    foo_user = volcengine.cloud_identity.User("fooUser",
        user_name="acc-test-user",
        display_name="tf-test-user",
        description="tf",
        email="88@qq.com",
        phone="181")
    foo_permission_set_assignment = volcengine.cloud_identity.PermissionSetAssignment("fooPermissionSetAssignment",
        permission_set_id=foo_permission_set.id,
        target_id="210026****",
        principal_type="User",
        principal_id=foo_user.id)
    foo_permission_set_assignments = volcengine.cloud_identity.permission_set_assignments_output(permission_set_id=foo_permission_set_assignment.permission_set_id)
    ```


    :param str name_regex: A Name Regex of Resource.
    :param str output_file: File name where to save data source results.
    :param str permission_set_id: The id of cloud identity permission set.
    :param str principal_id: The principal id of cloud identity permission set. When the `principal_type` is `User`, this field is specified to `UserId`. When the `principal_type` is `Group`, this field is specified to `GroupId`.
    :param str principal_type: The principal type of cloud identity permission set. Valid values: `User`, `Group`.
    :param str target_id: The target account id of cloud identity permission set assignment.
    """
    __args__ = dict()
    __args__['nameRegex'] = name_regex
    __args__['outputFile'] = output_file
    __args__['permissionSetId'] = permission_set_id
    __args__['principalId'] = principal_id
    __args__['principalType'] = principal_type
    __args__['targetId'] = target_id
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('volcengine:cloud_identity/permissionSetAssignments:PermissionSetAssignments', __args__, opts=opts, typ=PermissionSetAssignmentsResult).value

    return AwaitablePermissionSetAssignmentsResult(
        assignments=pulumi.get(__ret__, 'assignments'),
        id=pulumi.get(__ret__, 'id'),
        name_regex=pulumi.get(__ret__, 'name_regex'),
        output_file=pulumi.get(__ret__, 'output_file'),
        permission_set_id=pulumi.get(__ret__, 'permission_set_id'),
        principal_id=pulumi.get(__ret__, 'principal_id'),
        principal_type=pulumi.get(__ret__, 'principal_type'),
        target_id=pulumi.get(__ret__, 'target_id'),
        total_count=pulumi.get(__ret__, 'total_count'))


@_utilities.lift_output_func(permission_set_assignments)
def permission_set_assignments_output(name_regex: Optional[pulumi.Input[Optional[str]]] = None,
                                      output_file: Optional[pulumi.Input[Optional[str]]] = None,
                                      permission_set_id: Optional[pulumi.Input[Optional[str]]] = None,
                                      principal_id: Optional[pulumi.Input[Optional[str]]] = None,
                                      principal_type: Optional[pulumi.Input[Optional[str]]] = None,
                                      target_id: Optional[pulumi.Input[Optional[str]]] = None,
                                      opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[PermissionSetAssignmentsResult]:
    """
    Use this data source to query detailed information of cloud identity permission set assignments
    ## Example Usage

    ```python
    import pulumi
    import pulumi_volcengine as volcengine

    foo_permission_set = volcengine.cloud_identity.PermissionSet("fooPermissionSet",
        description="tf",
        session_duration=5000,
        permission_policies=[
            volcengine.cloud_identity.PermissionSetPermissionPolicyArgs(
                permission_policy_type="System",
                permission_policy_name="AdministratorAccess",
                inline_policy_document="",
            ),
            volcengine.cloud_identity.PermissionSetPermissionPolicyArgs(
                permission_policy_type="System",
                permission_policy_name="ReadOnlyAccess",
                inline_policy_document="",
            ),
            volcengine.cloud_identity.PermissionSetPermissionPolicyArgs(
                permission_policy_type="Inline",
                inline_policy_document="{\\"Statement\\":[{\\"Effect\\":\\"Allow\\",\\"Action\\":[\\"auto_scaling:DescribeScalingGroups\\"],\\"Resource\\":[\\"*\\"]}]}",
            ),
        ])
    foo_user = volcengine.cloud_identity.User("fooUser",
        user_name="acc-test-user",
        display_name="tf-test-user",
        description="tf",
        email="88@qq.com",
        phone="181")
    foo_permission_set_assignment = volcengine.cloud_identity.PermissionSetAssignment("fooPermissionSetAssignment",
        permission_set_id=foo_permission_set.id,
        target_id="210026****",
        principal_type="User",
        principal_id=foo_user.id)
    foo_permission_set_assignments = volcengine.cloud_identity.permission_set_assignments_output(permission_set_id=foo_permission_set_assignment.permission_set_id)
    ```


    :param str name_regex: A Name Regex of Resource.
    :param str output_file: File name where to save data source results.
    :param str permission_set_id: The id of cloud identity permission set.
    :param str principal_id: The principal id of cloud identity permission set. When the `principal_type` is `User`, this field is specified to `UserId`. When the `principal_type` is `Group`, this field is specified to `GroupId`.
    :param str principal_type: The principal type of cloud identity permission set. Valid values: `User`, `Group`.
    :param str target_id: The target account id of cloud identity permission set assignment.
    """
    ...
