# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from . import outputs

__all__ = [
    'UserProvisioningsResult',
    'AwaitableUserProvisioningsResult',
    'user_provisionings',
    'user_provisionings_output',
]

@pulumi.output_type
class UserProvisioningsResult:
    """
    A collection of values returned by UserProvisionings.
    """
    def __init__(__self__, account_id=None, id=None, output_file=None, total_count=None, user_provisionings=None):
        if account_id and not isinstance(account_id, str):
            raise TypeError("Expected argument 'account_id' to be a str")
        pulumi.set(__self__, "account_id", account_id)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if output_file and not isinstance(output_file, str):
            raise TypeError("Expected argument 'output_file' to be a str")
        pulumi.set(__self__, "output_file", output_file)
        if total_count and not isinstance(total_count, int):
            raise TypeError("Expected argument 'total_count' to be a int")
        pulumi.set(__self__, "total_count", total_count)
        if user_provisionings and not isinstance(user_provisionings, list):
            raise TypeError("Expected argument 'user_provisionings' to be a list")
        pulumi.set(__self__, "user_provisionings", user_provisionings)

    @property
    @pulumi.getter(name="accountId")
    def account_id(self) -> Optional[str]:
        return pulumi.get(self, "account_id")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="outputFile")
    def output_file(self) -> Optional[str]:
        return pulumi.get(self, "output_file")

    @property
    @pulumi.getter(name="totalCount")
    def total_count(self) -> int:
        """
        The total count of query.
        """
        return pulumi.get(self, "total_count")

    @property
    @pulumi.getter(name="userProvisionings")
    def user_provisionings(self) -> Sequence['outputs.UserProvisioningsUserProvisioningResult']:
        """
        The collection of query.
        """
        return pulumi.get(self, "user_provisionings")


class AwaitableUserProvisioningsResult(UserProvisioningsResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return UserProvisioningsResult(
            account_id=self.account_id,
            id=self.id,
            output_file=self.output_file,
            total_count=self.total_count,
            user_provisionings=self.user_provisionings)


def user_provisionings(account_id: Optional[str] = None,
                       output_file: Optional[str] = None,
                       opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableUserProvisioningsResult:
    """
    Use this data source to query detailed information of cloud identity user provisionings
    ## Example Usage

    ```python
    import pulumi
    import pulumi_volcengine as volcengine

    foo = volcengine.cloud_identity.user_provisionings(account_id="210026****")
    ```


    :param str account_id: The account id.
    :param str output_file: File name where to save data source results.
    """
    __args__ = dict()
    __args__['accountId'] = account_id
    __args__['outputFile'] = output_file
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('volcengine:cloud_identity/userProvisionings:UserProvisionings', __args__, opts=opts, typ=UserProvisioningsResult).value

    return AwaitableUserProvisioningsResult(
        account_id=pulumi.get(__ret__, 'account_id'),
        id=pulumi.get(__ret__, 'id'),
        output_file=pulumi.get(__ret__, 'output_file'),
        total_count=pulumi.get(__ret__, 'total_count'),
        user_provisionings=pulumi.get(__ret__, 'user_provisionings'))


@_utilities.lift_output_func(user_provisionings)
def user_provisionings_output(account_id: Optional[pulumi.Input[Optional[str]]] = None,
                              output_file: Optional[pulumi.Input[Optional[str]]] = None,
                              opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[UserProvisioningsResult]:
    """
    Use this data source to query detailed information of cloud identity user provisionings
    ## Example Usage

    ```python
    import pulumi
    import pulumi_volcengine as volcengine

    foo = volcengine.cloud_identity.user_provisionings(account_id="210026****")
    ```


    :param str account_id: The account id.
    :param str output_file: File name where to save data source results.
    """
    ...
