# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from . import outputs

__all__ = [
    'ImageSharePermissionsResult',
    'AwaitableImageSharePermissionsResult',
    'image_share_permissions',
    'image_share_permissions_output',
]

@pulumi.output_type
class ImageSharePermissionsResult:
    """
    A collection of values returned by ImageSharePermissions.
    """
    def __init__(__self__, accounts=None, id=None, image_id=None, output_file=None, total_count=None):
        if accounts and not isinstance(accounts, list):
            raise TypeError("Expected argument 'accounts' to be a list")
        pulumi.set(__self__, "accounts", accounts)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if image_id and not isinstance(image_id, str):
            raise TypeError("Expected argument 'image_id' to be a str")
        pulumi.set(__self__, "image_id", image_id)
        if output_file and not isinstance(output_file, str):
            raise TypeError("Expected argument 'output_file' to be a str")
        pulumi.set(__self__, "output_file", output_file)
        if total_count and not isinstance(total_count, int):
            raise TypeError("Expected argument 'total_count' to be a int")
        pulumi.set(__self__, "total_count", total_count)

    @property
    @pulumi.getter
    def accounts(self) -> Sequence['outputs.ImageSharePermissionsAccountResult']:
        """
        The collection of query.
        """
        return pulumi.get(self, "accounts")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="imageId")
    def image_id(self) -> str:
        return pulumi.get(self, "image_id")

    @property
    @pulumi.getter(name="outputFile")
    def output_file(self) -> Optional[str]:
        return pulumi.get(self, "output_file")

    @property
    @pulumi.getter(name="totalCount")
    def total_count(self) -> int:
        """
        The total count of query.
        """
        return pulumi.get(self, "total_count")


class AwaitableImageSharePermissionsResult(ImageSharePermissionsResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return ImageSharePermissionsResult(
            accounts=self.accounts,
            id=self.id,
            image_id=self.image_id,
            output_file=self.output_file,
            total_count=self.total_count)


def image_share_permissions(image_id: Optional[str] = None,
                            output_file: Optional[str] = None,
                            opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableImageSharePermissionsResult:
    """
    Use this data source to query detailed information of image share permissions
    ## Example Usage

    ```python
    import pulumi
    import pulumi_volcengine as volcengine

    foo = volcengine.ecs.image_share_permissions(image_id="image-ydi2wozhozfu03z2****")
    ```


    :param str image_id: The id of the image.
    :param str output_file: File name where to save data source results.
    """
    __args__ = dict()
    __args__['imageId'] = image_id
    __args__['outputFile'] = output_file
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('volcengine:ecs/imageSharePermissions:ImageSharePermissions', __args__, opts=opts, typ=ImageSharePermissionsResult).value

    return AwaitableImageSharePermissionsResult(
        accounts=pulumi.get(__ret__, 'accounts'),
        id=pulumi.get(__ret__, 'id'),
        image_id=pulumi.get(__ret__, 'image_id'),
        output_file=pulumi.get(__ret__, 'output_file'),
        total_count=pulumi.get(__ret__, 'total_count'))


@_utilities.lift_output_func(image_share_permissions)
def image_share_permissions_output(image_id: Optional[pulumi.Input[str]] = None,
                                   output_file: Optional[pulumi.Input[Optional[str]]] = None,
                                   opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[ImageSharePermissionsResult]:
    """
    Use this data source to query detailed information of image share permissions
    ## Example Usage

    ```python
    import pulumi
    import pulumi_volcengine as volcengine

    foo = volcengine.ecs.image_share_permissions(image_id="image-ydi2wozhozfu03z2****")
    ```


    :param str image_id: The id of the image.
    :param str output_file: File name where to save data source results.
    """
    ...
