# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from . import outputs

__all__ = [
    'ConsumedTopicsResult',
    'AwaitableConsumedTopicsResult',
    'consumed_topics',
    'consumed_topics_output',
]

@pulumi.output_type
class ConsumedTopicsResult:
    """
    A collection of values returned by ConsumedTopics.
    """
    def __init__(__self__, consumed_topics=None, group_id=None, id=None, instance_id=None, output_file=None, topic_name=None, total_count=None):
        if consumed_topics and not isinstance(consumed_topics, list):
            raise TypeError("Expected argument 'consumed_topics' to be a list")
        pulumi.set(__self__, "consumed_topics", consumed_topics)
        if group_id and not isinstance(group_id, str):
            raise TypeError("Expected argument 'group_id' to be a str")
        pulumi.set(__self__, "group_id", group_id)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if instance_id and not isinstance(instance_id, str):
            raise TypeError("Expected argument 'instance_id' to be a str")
        pulumi.set(__self__, "instance_id", instance_id)
        if output_file and not isinstance(output_file, str):
            raise TypeError("Expected argument 'output_file' to be a str")
        pulumi.set(__self__, "output_file", output_file)
        if topic_name and not isinstance(topic_name, str):
            raise TypeError("Expected argument 'topic_name' to be a str")
        pulumi.set(__self__, "topic_name", topic_name)
        if total_count and not isinstance(total_count, int):
            raise TypeError("Expected argument 'total_count' to be a int")
        pulumi.set(__self__, "total_count", total_count)

    @property
    @pulumi.getter(name="consumedTopics")
    def consumed_topics(self) -> Sequence['outputs.ConsumedTopicsConsumedTopicResult']:
        """
        The collection of query.
        """
        return pulumi.get(self, "consumed_topics")

    @property
    @pulumi.getter(name="groupId")
    def group_id(self) -> str:
        return pulumi.get(self, "group_id")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="instanceId")
    def instance_id(self) -> str:
        return pulumi.get(self, "instance_id")

    @property
    @pulumi.getter(name="outputFile")
    def output_file(self) -> Optional[str]:
        return pulumi.get(self, "output_file")

    @property
    @pulumi.getter(name="topicName")
    def topic_name(self) -> Optional[str]:
        """
        The name of kafka topic.
        """
        return pulumi.get(self, "topic_name")

    @property
    @pulumi.getter(name="totalCount")
    def total_count(self) -> int:
        """
        The total count of query.
        """
        return pulumi.get(self, "total_count")


class AwaitableConsumedTopicsResult(ConsumedTopicsResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return ConsumedTopicsResult(
            consumed_topics=self.consumed_topics,
            group_id=self.group_id,
            id=self.id,
            instance_id=self.instance_id,
            output_file=self.output_file,
            topic_name=self.topic_name,
            total_count=self.total_count)


def consumed_topics(group_id: Optional[str] = None,
                    instance_id: Optional[str] = None,
                    output_file: Optional[str] = None,
                    topic_name: Optional[str] = None,
                    opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableConsumedTopicsResult:
    """
    Use this data source to query detailed information of kafka consumed topics
    ## Example Usage

    ```python
    import pulumi
    import pulumi_volcengine as volcengine

    foo_zones = volcengine.ecs.zones()
    foo_vpc = volcengine.vpc.Vpc("fooVpc",
        vpc_name="acc-test-vpc",
        cidr_block="172.16.0.0/16")
    foo_subnet = volcengine.vpc.Subnet("fooSubnet",
        subnet_name="acc-test-subnet",
        cidr_block="172.16.0.0/24",
        zone_id=foo_zones.zones[0].id,
        vpc_id=foo_vpc.id)
    foo_instance = volcengine.kafka.Instance("fooInstance",
        instance_name="acc-test-kafka",
        instance_description="tf-test",
        version="2.2.2",
        compute_spec="kafka.20xrate.hw",
        subnet_id=foo_subnet.id,
        user_name="tf-user",
        user_password="tf-pass!@q1",
        charge_type="PostPaid",
        storage_space=300,
        partition_number=350,
        project_name="default",
        tags=[volcengine.kafka.InstanceTagArgs(
            key="k1",
            value="v1",
        )],
        parameters=[
            volcengine.kafka.InstanceParameterArgs(
                parameter_name="MessageMaxByte",
                parameter_value="12",
            ),
            volcengine.kafka.InstanceParameterArgs(
                parameter_name="LogRetentionHours",
                parameter_value="70",
            ),
        ])
    foo_group = volcengine.kafka.Group("fooGroup",
        instance_id=foo_instance.id,
        group_id="acc-test-group",
        description="tf-test")
    foo_sasl_user = volcengine.kafka.SaslUser("fooSaslUser",
        user_name="acc-test-user",
        instance_id=foo_instance.id,
        user_password="suqsnis123!",
        description="tf-test",
        all_authority=True,
        password_type="Scram")
    foo_topic = volcengine.kafka.Topic("fooTopic",
        topic_name="acc-test-topic",
        instance_id=foo_instance.id,
        description="tf-test",
        partition_number=15,
        replica_number=3,
        parameters=volcengine.kafka.TopicParametersArgs(
            min_insync_replica_number=2,
            message_max_byte=10,
            log_retention_hours=96,
        ),
        all_authority=False,
        access_policies=[volcengine.kafka.TopicAccessPolicyArgs(
            user_name=foo_sasl_user.user_name,
            access_policy="Pub",
        )])
    default = volcengine.kafka.consumed_topics_output(instance_id=foo_instance.id,
        group_id=foo_group.group_id,
        topic_name=foo_topic.topic_name)
    ```


    :param str group_id: The id of kafka group.
    :param str instance_id: The id of kafka instance.
    :param str output_file: File name where to save data source results.
    :param str topic_name: The name of kafka topic. This field supports fuzzy query.
    """
    __args__ = dict()
    __args__['groupId'] = group_id
    __args__['instanceId'] = instance_id
    __args__['outputFile'] = output_file
    __args__['topicName'] = topic_name
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('volcengine:kafka/consumedTopics:ConsumedTopics', __args__, opts=opts, typ=ConsumedTopicsResult).value

    return AwaitableConsumedTopicsResult(
        consumed_topics=pulumi.get(__ret__, 'consumed_topics'),
        group_id=pulumi.get(__ret__, 'group_id'),
        id=pulumi.get(__ret__, 'id'),
        instance_id=pulumi.get(__ret__, 'instance_id'),
        output_file=pulumi.get(__ret__, 'output_file'),
        topic_name=pulumi.get(__ret__, 'topic_name'),
        total_count=pulumi.get(__ret__, 'total_count'))


@_utilities.lift_output_func(consumed_topics)
def consumed_topics_output(group_id: Optional[pulumi.Input[str]] = None,
                           instance_id: Optional[pulumi.Input[str]] = None,
                           output_file: Optional[pulumi.Input[Optional[str]]] = None,
                           topic_name: Optional[pulumi.Input[Optional[str]]] = None,
                           opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[ConsumedTopicsResult]:
    """
    Use this data source to query detailed information of kafka consumed topics
    ## Example Usage

    ```python
    import pulumi
    import pulumi_volcengine as volcengine

    foo_zones = volcengine.ecs.zones()
    foo_vpc = volcengine.vpc.Vpc("fooVpc",
        vpc_name="acc-test-vpc",
        cidr_block="172.16.0.0/16")
    foo_subnet = volcengine.vpc.Subnet("fooSubnet",
        subnet_name="acc-test-subnet",
        cidr_block="172.16.0.0/24",
        zone_id=foo_zones.zones[0].id,
        vpc_id=foo_vpc.id)
    foo_instance = volcengine.kafka.Instance("fooInstance",
        instance_name="acc-test-kafka",
        instance_description="tf-test",
        version="2.2.2",
        compute_spec="kafka.20xrate.hw",
        subnet_id=foo_subnet.id,
        user_name="tf-user",
        user_password="tf-pass!@q1",
        charge_type="PostPaid",
        storage_space=300,
        partition_number=350,
        project_name="default",
        tags=[volcengine.kafka.InstanceTagArgs(
            key="k1",
            value="v1",
        )],
        parameters=[
            volcengine.kafka.InstanceParameterArgs(
                parameter_name="MessageMaxByte",
                parameter_value="12",
            ),
            volcengine.kafka.InstanceParameterArgs(
                parameter_name="LogRetentionHours",
                parameter_value="70",
            ),
        ])
    foo_group = volcengine.kafka.Group("fooGroup",
        instance_id=foo_instance.id,
        group_id="acc-test-group",
        description="tf-test")
    foo_sasl_user = volcengine.kafka.SaslUser("fooSaslUser",
        user_name="acc-test-user",
        instance_id=foo_instance.id,
        user_password="suqsnis123!",
        description="tf-test",
        all_authority=True,
        password_type="Scram")
    foo_topic = volcengine.kafka.Topic("fooTopic",
        topic_name="acc-test-topic",
        instance_id=foo_instance.id,
        description="tf-test",
        partition_number=15,
        replica_number=3,
        parameters=volcengine.kafka.TopicParametersArgs(
            min_insync_replica_number=2,
            message_max_byte=10,
            log_retention_hours=96,
        ),
        all_authority=False,
        access_policies=[volcengine.kafka.TopicAccessPolicyArgs(
            user_name=foo_sasl_user.user_name,
            access_policy="Pub",
        )])
    default = volcengine.kafka.consumed_topics_output(instance_id=foo_instance.id,
        group_id=foo_group.group_id,
        topic_name=foo_topic.topic_name)
    ```


    :param str group_id: The id of kafka group.
    :param str instance_id: The id of kafka instance.
    :param str output_file: File name where to save data source results.
    :param str topic_name: The name of kafka topic. This field supports fuzzy query.
    """
    ...
