# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from . import outputs

__all__ = [
    'AllowlistsResult',
    'AwaitableAllowlistsResult',
    'allowlists',
    'allowlists_output',
]

@pulumi.output_type
class AllowlistsResult:
    """
    A collection of values returned by Allowlists.
    """
    def __init__(__self__, id=None, instance_id=None, name_regex=None, output_file=None, postgresql_allow_lists=None, total_count=None):
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if instance_id and not isinstance(instance_id, str):
            raise TypeError("Expected argument 'instance_id' to be a str")
        pulumi.set(__self__, "instance_id", instance_id)
        if name_regex and not isinstance(name_regex, str):
            raise TypeError("Expected argument 'name_regex' to be a str")
        pulumi.set(__self__, "name_regex", name_regex)
        if output_file and not isinstance(output_file, str):
            raise TypeError("Expected argument 'output_file' to be a str")
        pulumi.set(__self__, "output_file", output_file)
        if postgresql_allow_lists and not isinstance(postgresql_allow_lists, list):
            raise TypeError("Expected argument 'postgresql_allow_lists' to be a list")
        pulumi.set(__self__, "postgresql_allow_lists", postgresql_allow_lists)
        if total_count and not isinstance(total_count, int):
            raise TypeError("Expected argument 'total_count' to be a int")
        pulumi.set(__self__, "total_count", total_count)

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="instanceId")
    def instance_id(self) -> Optional[str]:
        """
        The id of the postgresql instance.
        """
        return pulumi.get(self, "instance_id")

    @property
    @pulumi.getter(name="nameRegex")
    def name_regex(self) -> Optional[str]:
        return pulumi.get(self, "name_regex")

    @property
    @pulumi.getter(name="outputFile")
    def output_file(self) -> Optional[str]:
        return pulumi.get(self, "output_file")

    @property
    @pulumi.getter(name="postgresqlAllowLists")
    def postgresql_allow_lists(self) -> Sequence['outputs.AllowlistsPostgresqlAllowListResult']:
        """
        The list of postgresql allowed list.
        """
        return pulumi.get(self, "postgresql_allow_lists")

    @property
    @pulumi.getter(name="totalCount")
    def total_count(self) -> int:
        """
        The total count of query.
        """
        return pulumi.get(self, "total_count")


class AwaitableAllowlistsResult(AllowlistsResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return AllowlistsResult(
            id=self.id,
            instance_id=self.instance_id,
            name_regex=self.name_regex,
            output_file=self.output_file,
            postgresql_allow_lists=self.postgresql_allow_lists,
            total_count=self.total_count)


def allowlists(instance_id: Optional[str] = None,
               name_regex: Optional[str] = None,
               output_file: Optional[str] = None,
               opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableAllowlistsResult:
    """
    Use this data source to query detailed information of rds postgresql allowlists
    ## Example Usage

    ```python
    import pulumi
    import pulumi_volcengine as volcengine

    foo = volcengine.rds_postgresql.allowlists()
    ```


    :param str instance_id: The id of the postgresql Instance.
    :param str name_regex: A Name Regex of Resource.
    :param str output_file: File name where to save data source results.
    """
    __args__ = dict()
    __args__['instanceId'] = instance_id
    __args__['nameRegex'] = name_regex
    __args__['outputFile'] = output_file
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('volcengine:rds_postgresql/allowlists:Allowlists', __args__, opts=opts, typ=AllowlistsResult).value

    return AwaitableAllowlistsResult(
        id=pulumi.get(__ret__, 'id'),
        instance_id=pulumi.get(__ret__, 'instance_id'),
        name_regex=pulumi.get(__ret__, 'name_regex'),
        output_file=pulumi.get(__ret__, 'output_file'),
        postgresql_allow_lists=pulumi.get(__ret__, 'postgresql_allow_lists'),
        total_count=pulumi.get(__ret__, 'total_count'))


@_utilities.lift_output_func(allowlists)
def allowlists_output(instance_id: Optional[pulumi.Input[Optional[str]]] = None,
                      name_regex: Optional[pulumi.Input[Optional[str]]] = None,
                      output_file: Optional[pulumi.Input[Optional[str]]] = None,
                      opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[AllowlistsResult]:
    """
    Use this data source to query detailed information of rds postgresql allowlists
    ## Example Usage

    ```python
    import pulumi
    import pulumi_volcengine as volcengine

    foo = volcengine.rds_postgresql.allowlists()
    ```


    :param str instance_id: The id of the postgresql Instance.
    :param str name_regex: A Name Regex of Resource.
    :param str output_file: File name where to save data source results.
    """
    ...
