# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities

__all__ = ['RouteTableAssociationArgs', 'RouteTableAssociation']

@pulumi.input_type
class RouteTableAssociationArgs:
    def __init__(__self__, *,
                 transit_router_attachment_id: pulumi.Input[str],
                 transit_router_route_table_id: pulumi.Input[str]):
        """
        The set of arguments for constructing a RouteTableAssociation resource.
        :param pulumi.Input[str] transit_router_attachment_id: The ID of the network instance connection.
        :param pulumi.Input[str] transit_router_route_table_id: The ID of the routing table associated with the transit router instance.
        """
        pulumi.set(__self__, "transit_router_attachment_id", transit_router_attachment_id)
        pulumi.set(__self__, "transit_router_route_table_id", transit_router_route_table_id)

    @property
    @pulumi.getter(name="transitRouterAttachmentId")
    def transit_router_attachment_id(self) -> pulumi.Input[str]:
        """
        The ID of the network instance connection.
        """
        return pulumi.get(self, "transit_router_attachment_id")

    @transit_router_attachment_id.setter
    def transit_router_attachment_id(self, value: pulumi.Input[str]):
        pulumi.set(self, "transit_router_attachment_id", value)

    @property
    @pulumi.getter(name="transitRouterRouteTableId")
    def transit_router_route_table_id(self) -> pulumi.Input[str]:
        """
        The ID of the routing table associated with the transit router instance.
        """
        return pulumi.get(self, "transit_router_route_table_id")

    @transit_router_route_table_id.setter
    def transit_router_route_table_id(self, value: pulumi.Input[str]):
        pulumi.set(self, "transit_router_route_table_id", value)


@pulumi.input_type
class _RouteTableAssociationState:
    def __init__(__self__, *,
                 transit_router_attachment_id: Optional[pulumi.Input[str]] = None,
                 transit_router_route_table_id: Optional[pulumi.Input[str]] = None):
        """
        Input properties used for looking up and filtering RouteTableAssociation resources.
        :param pulumi.Input[str] transit_router_attachment_id: The ID of the network instance connection.
        :param pulumi.Input[str] transit_router_route_table_id: The ID of the routing table associated with the transit router instance.
        """
        if transit_router_attachment_id is not None:
            pulumi.set(__self__, "transit_router_attachment_id", transit_router_attachment_id)
        if transit_router_route_table_id is not None:
            pulumi.set(__self__, "transit_router_route_table_id", transit_router_route_table_id)

    @property
    @pulumi.getter(name="transitRouterAttachmentId")
    def transit_router_attachment_id(self) -> Optional[pulumi.Input[str]]:
        """
        The ID of the network instance connection.
        """
        return pulumi.get(self, "transit_router_attachment_id")

    @transit_router_attachment_id.setter
    def transit_router_attachment_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "transit_router_attachment_id", value)

    @property
    @pulumi.getter(name="transitRouterRouteTableId")
    def transit_router_route_table_id(self) -> Optional[pulumi.Input[str]]:
        """
        The ID of the routing table associated with the transit router instance.
        """
        return pulumi.get(self, "transit_router_route_table_id")

    @transit_router_route_table_id.setter
    def transit_router_route_table_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "transit_router_route_table_id", value)


class RouteTableAssociation(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 transit_router_attachment_id: Optional[pulumi.Input[str]] = None,
                 transit_router_route_table_id: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        """
        Provides a resource to manage transit router route table association
        ## Example Usage

        ```python
        import pulumi
        import pulumi_volcengine as volcengine

        foo_transit_router = volcengine.transit_router.TransitRouter("fooTransitRouter",
            transit_router_name="test-tf-acc",
            description="test-tf-acc")
        foo_route_table = volcengine.transit_router.RouteTable("fooRouteTable",
            description="tf-test-acc-description",
            transit_router_route_table_name="tf-table-test-acc",
            transit_router_id=foo_transit_router.id)
        foo_customer_gateway = volcengine.vpn.CustomerGateway("fooCustomerGateway",
            ip_address="192.0.1.3",
            customer_gateway_name="acc-test",
            description="acc-test")
        foo_connection = volcengine.vpn.Connection("fooConnection",
            vpn_connection_name="acc-tf-test",
            description="acc-tf-test",
            attach_type="TransitRouter",
            customer_gateway_id=foo_customer_gateway.id,
            local_subnets=["192.168.0.0/22"],
            remote_subnets=["192.161.0.0/20"],
            dpd_action="none",
            nat_traversal=True,
            ike_config_psk="acctest@!3",
            ike_config_version="ikev1",
            ike_config_mode="main",
            ike_config_enc_alg="aes",
            ike_config_auth_alg="md5",
            ike_config_dh_group="group2",
            ike_config_lifetime=9000,
            ike_config_local_id="acc_test",
            ike_config_remote_id="acc_test",
            ipsec_config_enc_alg="aes",
            ipsec_config_auth_alg="sha256",
            ipsec_config_dh_group="group2",
            ipsec_config_lifetime=9000,
            log_enabled=False)
        foo_vpn_attachment = volcengine.transit_router.VpnAttachment("fooVpnAttachment",
            zone_id="cn-beijing-a",
            transit_router_attachment_name="tf-test-acc",
            description="tf-test-acc-desc",
            transit_router_id=foo_transit_router.id,
            vpn_connection_id=foo_connection.id)
        foo_route_table_association = volcengine.transit_router.RouteTableAssociation("fooRouteTableAssociation",
            transit_router_attachment_id=foo_vpn_attachment.transit_router_attachment_id,
            transit_router_route_table_id=foo_route_table.transit_router_route_table_id)
        ```

        ## Import

        TransitRouterRouteTableAssociation can be imported using the TransitRouterAttachmentId:TransitRouterRouteTableId, e.g.

        ```sh
        $ pulumi import volcengine:transit_router/routeTableAssociation:RouteTableAssociation default tr-attach-13n2l4c****:tr-rt-1i5i8khf9m58gae5kcx6****
        ```

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] transit_router_attachment_id: The ID of the network instance connection.
        :param pulumi.Input[str] transit_router_route_table_id: The ID of the routing table associated with the transit router instance.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: RouteTableAssociationArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Provides a resource to manage transit router route table association
        ## Example Usage

        ```python
        import pulumi
        import pulumi_volcengine as volcengine

        foo_transit_router = volcengine.transit_router.TransitRouter("fooTransitRouter",
            transit_router_name="test-tf-acc",
            description="test-tf-acc")
        foo_route_table = volcengine.transit_router.RouteTable("fooRouteTable",
            description="tf-test-acc-description",
            transit_router_route_table_name="tf-table-test-acc",
            transit_router_id=foo_transit_router.id)
        foo_customer_gateway = volcengine.vpn.CustomerGateway("fooCustomerGateway",
            ip_address="192.0.1.3",
            customer_gateway_name="acc-test",
            description="acc-test")
        foo_connection = volcengine.vpn.Connection("fooConnection",
            vpn_connection_name="acc-tf-test",
            description="acc-tf-test",
            attach_type="TransitRouter",
            customer_gateway_id=foo_customer_gateway.id,
            local_subnets=["192.168.0.0/22"],
            remote_subnets=["192.161.0.0/20"],
            dpd_action="none",
            nat_traversal=True,
            ike_config_psk="acctest@!3",
            ike_config_version="ikev1",
            ike_config_mode="main",
            ike_config_enc_alg="aes",
            ike_config_auth_alg="md5",
            ike_config_dh_group="group2",
            ike_config_lifetime=9000,
            ike_config_local_id="acc_test",
            ike_config_remote_id="acc_test",
            ipsec_config_enc_alg="aes",
            ipsec_config_auth_alg="sha256",
            ipsec_config_dh_group="group2",
            ipsec_config_lifetime=9000,
            log_enabled=False)
        foo_vpn_attachment = volcengine.transit_router.VpnAttachment("fooVpnAttachment",
            zone_id="cn-beijing-a",
            transit_router_attachment_name="tf-test-acc",
            description="tf-test-acc-desc",
            transit_router_id=foo_transit_router.id,
            vpn_connection_id=foo_connection.id)
        foo_route_table_association = volcengine.transit_router.RouteTableAssociation("fooRouteTableAssociation",
            transit_router_attachment_id=foo_vpn_attachment.transit_router_attachment_id,
            transit_router_route_table_id=foo_route_table.transit_router_route_table_id)
        ```

        ## Import

        TransitRouterRouteTableAssociation can be imported using the TransitRouterAttachmentId:TransitRouterRouteTableId, e.g.

        ```sh
        $ pulumi import volcengine:transit_router/routeTableAssociation:RouteTableAssociation default tr-attach-13n2l4c****:tr-rt-1i5i8khf9m58gae5kcx6****
        ```

        :param str resource_name: The name of the resource.
        :param RouteTableAssociationArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(RouteTableAssociationArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 transit_router_attachment_id: Optional[pulumi.Input[str]] = None,
                 transit_router_route_table_id: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = RouteTableAssociationArgs.__new__(RouteTableAssociationArgs)

            if transit_router_attachment_id is None and not opts.urn:
                raise TypeError("Missing required property 'transit_router_attachment_id'")
            __props__.__dict__["transit_router_attachment_id"] = transit_router_attachment_id
            if transit_router_route_table_id is None and not opts.urn:
                raise TypeError("Missing required property 'transit_router_route_table_id'")
            __props__.__dict__["transit_router_route_table_id"] = transit_router_route_table_id
        super(RouteTableAssociation, __self__).__init__(
            'volcengine:transit_router/routeTableAssociation:RouteTableAssociation',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            transit_router_attachment_id: Optional[pulumi.Input[str]] = None,
            transit_router_route_table_id: Optional[pulumi.Input[str]] = None) -> 'RouteTableAssociation':
        """
        Get an existing RouteTableAssociation resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] transit_router_attachment_id: The ID of the network instance connection.
        :param pulumi.Input[str] transit_router_route_table_id: The ID of the routing table associated with the transit router instance.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _RouteTableAssociationState.__new__(_RouteTableAssociationState)

        __props__.__dict__["transit_router_attachment_id"] = transit_router_attachment_id
        __props__.__dict__["transit_router_route_table_id"] = transit_router_route_table_id
        return RouteTableAssociation(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="transitRouterAttachmentId")
    def transit_router_attachment_id(self) -> pulumi.Output[str]:
        """
        The ID of the network instance connection.
        """
        return pulumi.get(self, "transit_router_attachment_id")

    @property
    @pulumi.getter(name="transitRouterRouteTableId")
    def transit_router_route_table_id(self) -> pulumi.Output[str]:
        """
        The ID of the routing table associated with the transit router instance.
        """
        return pulumi.get(self, "transit_router_route_table_id")

