# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from . import outputs

__all__ = [
    'BackupsResult',
    'AwaitableBackupsResult',
    'backups',
    'backups_output',
]

@pulumi.output_type
class BackupsResult:
    """
    A collection of values returned by Backups.
    """
    def __init__(__self__, backup_end_time=None, backup_method=None, backup_start_time=None, backup_status=None, backup_type=None, backups=None, id=None, instance_id=None, output_file=None, total_count=None):
        if backup_end_time and not isinstance(backup_end_time, str):
            raise TypeError("Expected argument 'backup_end_time' to be a str")
        pulumi.set(__self__, "backup_end_time", backup_end_time)
        if backup_method and not isinstance(backup_method, str):
            raise TypeError("Expected argument 'backup_method' to be a str")
        pulumi.set(__self__, "backup_method", backup_method)
        if backup_start_time and not isinstance(backup_start_time, str):
            raise TypeError("Expected argument 'backup_start_time' to be a str")
        pulumi.set(__self__, "backup_start_time", backup_start_time)
        if backup_status and not isinstance(backup_status, str):
            raise TypeError("Expected argument 'backup_status' to be a str")
        pulumi.set(__self__, "backup_status", backup_status)
        if backup_type and not isinstance(backup_type, str):
            raise TypeError("Expected argument 'backup_type' to be a str")
        pulumi.set(__self__, "backup_type", backup_type)
        if backups and not isinstance(backups, list):
            raise TypeError("Expected argument 'backups' to be a list")
        pulumi.set(__self__, "backups", backups)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if instance_id and not isinstance(instance_id, str):
            raise TypeError("Expected argument 'instance_id' to be a str")
        pulumi.set(__self__, "instance_id", instance_id)
        if output_file and not isinstance(output_file, str):
            raise TypeError("Expected argument 'output_file' to be a str")
        pulumi.set(__self__, "output_file", output_file)
        if total_count and not isinstance(total_count, int):
            raise TypeError("Expected argument 'total_count' to be a int")
        pulumi.set(__self__, "total_count", total_count)

    @property
    @pulumi.getter(name="backupEndTime")
    def backup_end_time(self) -> Optional[str]:
        """
        The end time of the backup.
        """
        return pulumi.get(self, "backup_end_time")

    @property
    @pulumi.getter(name="backupMethod")
    def backup_method(self) -> Optional[str]:
        """
        The name of the backup method.
        """
        return pulumi.get(self, "backup_method")

    @property
    @pulumi.getter(name="backupStartTime")
    def backup_start_time(self) -> Optional[str]:
        """
        The start time of the backup.
        """
        return pulumi.get(self, "backup_start_time")

    @property
    @pulumi.getter(name="backupStatus")
    def backup_status(self) -> Optional[str]:
        """
        The status of the backup.
        """
        return pulumi.get(self, "backup_status")

    @property
    @pulumi.getter(name="backupType")
    def backup_type(self) -> Optional[str]:
        """
        The type of the backup.
        """
        return pulumi.get(self, "backup_type")

    @property
    @pulumi.getter
    def backups(self) -> Sequence['outputs.BackupsBackupResult']:
        """
        The collection of query.
        """
        return pulumi.get(self, "backups")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="instanceId")
    def instance_id(self) -> str:
        """
        The id of the instance.
        """
        return pulumi.get(self, "instance_id")

    @property
    @pulumi.getter(name="outputFile")
    def output_file(self) -> Optional[str]:
        return pulumi.get(self, "output_file")

    @property
    @pulumi.getter(name="totalCount")
    def total_count(self) -> int:
        """
        The total count of query.
        """
        return pulumi.get(self, "total_count")


class AwaitableBackupsResult(BackupsResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return BackupsResult(
            backup_end_time=self.backup_end_time,
            backup_method=self.backup_method,
            backup_start_time=self.backup_start_time,
            backup_status=self.backup_status,
            backup_type=self.backup_type,
            backups=self.backups,
            id=self.id,
            instance_id=self.instance_id,
            output_file=self.output_file,
            total_count=self.total_count)


def backups(backup_end_time: Optional[str] = None,
            backup_method: Optional[str] = None,
            backup_start_time: Optional[str] = None,
            backup_status: Optional[str] = None,
            backup_type: Optional[str] = None,
            instance_id: Optional[str] = None,
            output_file: Optional[str] = None,
            opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableBackupsResult:
    """
    Use this data source to query detailed information of vedb mysql backups
    ## Example Usage

    ```python
    import pulumi
    import pulumi_volcengine as volcengine

    foo_zones = volcengine.ecs.zones()
    foo_vpc = volcengine.vpc.Vpc("fooVpc",
        vpc_name="acc-test-vpc",
        cidr_block="172.16.0.0/16")
    foo_subnet = volcengine.vpc.Subnet("fooSubnet",
        subnet_name="acc-test-subnet",
        cidr_block="172.16.0.0/24",
        zone_id=foo_zones.zones[2].id,
        vpc_id=foo_vpc.id)
    foo_instance = volcengine.vedb_mysql.Instance("fooInstance",
        charge_type="PostPaid",
        storage_charge_type="PostPaid",
        db_engine_version="MySQL_8_0",
        db_minor_version="3.0",
        node_number=2,
        node_spec="vedb.mysql.x4.large",
        subnet_id=foo_subnet.id,
        instance_name="tf-test",
        project_name="testA",
        tags=[
            volcengine.vedb_mysql.InstanceTagArgs(
                key="tftest",
                value="tftest",
            ),
            volcengine.vedb_mysql.InstanceTagArgs(
                key="tftest2",
                value="tftest2",
            ),
        ])
    foo_backup = volcengine.vedb_mysql.Backup("fooBackup",
        instance_id=foo_instance.id,
        backup_policy=volcengine.vedb_mysql.BackupBackupPolicyArgs(
            backup_time="18:00Z-20:00Z",
            full_backup_period="Monday,Tuesday,Wednesday",
            backup_retention_period=8,
        ))
    foo_backups = volcengine.vedb_mysql.backups_output(instance_id=foo_instance.id)
    ```


    :param str backup_end_time: The end time of the backup.
    :param str backup_method: Backup method. Currently, only physical backup is supported. The value is Physical.
    :param str backup_start_time: The start time of the backup.
    :param str backup_status: The status of the backup.
    :param str backup_type: The type of the backup.
    :param str instance_id: The id of the instance.
    :param str output_file: File name where to save data source results.
    """
    __args__ = dict()
    __args__['backupEndTime'] = backup_end_time
    __args__['backupMethod'] = backup_method
    __args__['backupStartTime'] = backup_start_time
    __args__['backupStatus'] = backup_status
    __args__['backupType'] = backup_type
    __args__['instanceId'] = instance_id
    __args__['outputFile'] = output_file
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('volcengine:vedb_mysql/backups:Backups', __args__, opts=opts, typ=BackupsResult).value

    return AwaitableBackupsResult(
        backup_end_time=pulumi.get(__ret__, 'backup_end_time'),
        backup_method=pulumi.get(__ret__, 'backup_method'),
        backup_start_time=pulumi.get(__ret__, 'backup_start_time'),
        backup_status=pulumi.get(__ret__, 'backup_status'),
        backup_type=pulumi.get(__ret__, 'backup_type'),
        backups=pulumi.get(__ret__, 'backups'),
        id=pulumi.get(__ret__, 'id'),
        instance_id=pulumi.get(__ret__, 'instance_id'),
        output_file=pulumi.get(__ret__, 'output_file'),
        total_count=pulumi.get(__ret__, 'total_count'))


@_utilities.lift_output_func(backups)
def backups_output(backup_end_time: Optional[pulumi.Input[Optional[str]]] = None,
                   backup_method: Optional[pulumi.Input[Optional[str]]] = None,
                   backup_start_time: Optional[pulumi.Input[Optional[str]]] = None,
                   backup_status: Optional[pulumi.Input[Optional[str]]] = None,
                   backup_type: Optional[pulumi.Input[Optional[str]]] = None,
                   instance_id: Optional[pulumi.Input[str]] = None,
                   output_file: Optional[pulumi.Input[Optional[str]]] = None,
                   opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[BackupsResult]:
    """
    Use this data source to query detailed information of vedb mysql backups
    ## Example Usage

    ```python
    import pulumi
    import pulumi_volcengine as volcengine

    foo_zones = volcengine.ecs.zones()
    foo_vpc = volcengine.vpc.Vpc("fooVpc",
        vpc_name="acc-test-vpc",
        cidr_block="172.16.0.0/16")
    foo_subnet = volcengine.vpc.Subnet("fooSubnet",
        subnet_name="acc-test-subnet",
        cidr_block="172.16.0.0/24",
        zone_id=foo_zones.zones[2].id,
        vpc_id=foo_vpc.id)
    foo_instance = volcengine.vedb_mysql.Instance("fooInstance",
        charge_type="PostPaid",
        storage_charge_type="PostPaid",
        db_engine_version="MySQL_8_0",
        db_minor_version="3.0",
        node_number=2,
        node_spec="vedb.mysql.x4.large",
        subnet_id=foo_subnet.id,
        instance_name="tf-test",
        project_name="testA",
        tags=[
            volcengine.vedb_mysql.InstanceTagArgs(
                key="tftest",
                value="tftest",
            ),
            volcengine.vedb_mysql.InstanceTagArgs(
                key="tftest2",
                value="tftest2",
            ),
        ])
    foo_backup = volcengine.vedb_mysql.Backup("fooBackup",
        instance_id=foo_instance.id,
        backup_policy=volcengine.vedb_mysql.BackupBackupPolicyArgs(
            backup_time="18:00Z-20:00Z",
            full_backup_period="Monday,Tuesday,Wednesday",
            backup_retention_period=8,
        ))
    foo_backups = volcengine.vedb_mysql.backups_output(instance_id=foo_instance.id)
    ```


    :param str backup_end_time: The end time of the backup.
    :param str backup_method: Backup method. Currently, only physical backup is supported. The value is Physical.
    :param str backup_start_time: The start time of the backup.
    :param str backup_status: The status of the backup.
    :param str backup_type: The type of the backup.
    :param str instance_id: The id of the instance.
    :param str output_file: File name where to save data source results.
    """
    ...
