# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from . import outputs
from ._inputs import *

__all__ = ['FileSystemArgs', 'FileSystem']

@pulumi.input_type
class FileSystemArgs:
    def __init__(__self__, *,
                 capacity: pulumi.Input[int],
                 file_system_name: pulumi.Input[str],
                 store_type: pulumi.Input[str],
                 subnet_id: pulumi.Input[str],
                 description: Optional[pulumi.Input[str]] = None,
                 enable_restripe: Optional[pulumi.Input[bool]] = None,
                 project: Optional[pulumi.Input[str]] = None,
                 tags: Optional[pulumi.Input[Sequence[pulumi.Input['FileSystemTagArgs']]]] = None):
        """
        The set of arguments for constructing a FileSystem resource.
        :param pulumi.Input[int] capacity: The capacity of the vepfs file system.
        :param pulumi.Input[str] file_system_name: The name of the vepfs file system.
        :param pulumi.Input[str] store_type: The store type of the vepfs file system. Valid values: `Advance_100`, `Performance`, `Intelligent_Computing`.
        :param pulumi.Input[str] subnet_id: The subnet id of the vepfs file system.
        :param pulumi.Input[str] description: The description info of the vepfs file system.
        :param pulumi.Input[bool] enable_restripe: Whether to enable data balance after capacity expansion. This filed is valid only when expanding capacity.
        :param pulumi.Input[str] project: The project of the vepfs file system.
        :param pulumi.Input[Sequence[pulumi.Input['FileSystemTagArgs']]] tags: Tags.
        """
        pulumi.set(__self__, "capacity", capacity)
        pulumi.set(__self__, "file_system_name", file_system_name)
        pulumi.set(__self__, "store_type", store_type)
        pulumi.set(__self__, "subnet_id", subnet_id)
        if description is not None:
            pulumi.set(__self__, "description", description)
        if enable_restripe is not None:
            pulumi.set(__self__, "enable_restripe", enable_restripe)
        if project is not None:
            pulumi.set(__self__, "project", project)
        if tags is not None:
            pulumi.set(__self__, "tags", tags)

    @property
    @pulumi.getter
    def capacity(self) -> pulumi.Input[int]:
        """
        The capacity of the vepfs file system.
        """
        return pulumi.get(self, "capacity")

    @capacity.setter
    def capacity(self, value: pulumi.Input[int]):
        pulumi.set(self, "capacity", value)

    @property
    @pulumi.getter(name="fileSystemName")
    def file_system_name(self) -> pulumi.Input[str]:
        """
        The name of the vepfs file system.
        """
        return pulumi.get(self, "file_system_name")

    @file_system_name.setter
    def file_system_name(self, value: pulumi.Input[str]):
        pulumi.set(self, "file_system_name", value)

    @property
    @pulumi.getter(name="storeType")
    def store_type(self) -> pulumi.Input[str]:
        """
        The store type of the vepfs file system. Valid values: `Advance_100`, `Performance`, `Intelligent_Computing`.
        """
        return pulumi.get(self, "store_type")

    @store_type.setter
    def store_type(self, value: pulumi.Input[str]):
        pulumi.set(self, "store_type", value)

    @property
    @pulumi.getter(name="subnetId")
    def subnet_id(self) -> pulumi.Input[str]:
        """
        The subnet id of the vepfs file system.
        """
        return pulumi.get(self, "subnet_id")

    @subnet_id.setter
    def subnet_id(self, value: pulumi.Input[str]):
        pulumi.set(self, "subnet_id", value)

    @property
    @pulumi.getter
    def description(self) -> Optional[pulumi.Input[str]]:
        """
        The description info of the vepfs file system.
        """
        return pulumi.get(self, "description")

    @description.setter
    def description(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "description", value)

    @property
    @pulumi.getter(name="enableRestripe")
    def enable_restripe(self) -> Optional[pulumi.Input[bool]]:
        """
        Whether to enable data balance after capacity expansion. This filed is valid only when expanding capacity.
        """
        return pulumi.get(self, "enable_restripe")

    @enable_restripe.setter
    def enable_restripe(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "enable_restripe", value)

    @property
    @pulumi.getter
    def project(self) -> Optional[pulumi.Input[str]]:
        """
        The project of the vepfs file system.
        """
        return pulumi.get(self, "project")

    @project.setter
    def project(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "project", value)

    @property
    @pulumi.getter
    def tags(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['FileSystemTagArgs']]]]:
        """
        Tags.
        """
        return pulumi.get(self, "tags")

    @tags.setter
    def tags(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['FileSystemTagArgs']]]]):
        pulumi.set(self, "tags", value)


@pulumi.input_type
class _FileSystemState:
    def __init__(__self__, *,
                 account_id: Optional[pulumi.Input[str]] = None,
                 bandwidth: Optional[pulumi.Input[int]] = None,
                 capacity: Optional[pulumi.Input[int]] = None,
                 charge_status: Optional[pulumi.Input[str]] = None,
                 charge_type: Optional[pulumi.Input[str]] = None,
                 create_time: Optional[pulumi.Input[str]] = None,
                 description: Optional[pulumi.Input[str]] = None,
                 enable_restripe: Optional[pulumi.Input[bool]] = None,
                 expire_time: Optional[pulumi.Input[str]] = None,
                 file_system_name: Optional[pulumi.Input[str]] = None,
                 file_system_type: Optional[pulumi.Input[str]] = None,
                 free_time: Optional[pulumi.Input[str]] = None,
                 last_modify_time: Optional[pulumi.Input[str]] = None,
                 project: Optional[pulumi.Input[str]] = None,
                 protocol_type: Optional[pulumi.Input[str]] = None,
                 region_id: Optional[pulumi.Input[str]] = None,
                 status: Optional[pulumi.Input[str]] = None,
                 stop_service_time: Optional[pulumi.Input[str]] = None,
                 store_type: Optional[pulumi.Input[str]] = None,
                 store_type_cn: Optional[pulumi.Input[str]] = None,
                 subnet_id: Optional[pulumi.Input[str]] = None,
                 tags: Optional[pulumi.Input[Sequence[pulumi.Input['FileSystemTagArgs']]]] = None,
                 version: Optional[pulumi.Input[str]] = None,
                 zone_id: Optional[pulumi.Input[str]] = None,
                 zone_name: Optional[pulumi.Input[str]] = None):
        """
        Input properties used for looking up and filtering FileSystem resources.
        :param pulumi.Input[str] account_id: The id of the account.
        :param pulumi.Input[int] bandwidth: The bandwidth info of the vepfs file system.
        :param pulumi.Input[int] capacity: The capacity of the vepfs file system.
        :param pulumi.Input[str] charge_status: The charge status of the vepfs file system.
        :param pulumi.Input[str] charge_type: The charge type of the vepfs file system.
        :param pulumi.Input[str] create_time: The create time of the vepfs file system.
        :param pulumi.Input[str] description: The description info of the vepfs file system.
        :param pulumi.Input[bool] enable_restripe: Whether to enable data balance after capacity expansion. This filed is valid only when expanding capacity.
        :param pulumi.Input[str] expire_time: The expire time of the vepfs file system.
        :param pulumi.Input[str] file_system_name: The name of the vepfs file system.
        :param pulumi.Input[str] file_system_type: The type of the vepfs file system.
        :param pulumi.Input[str] free_time: The free time of the vepfs file system.
        :param pulumi.Input[str] last_modify_time: The last modify time of the vepfs file system.
        :param pulumi.Input[str] project: The project of the vepfs file system.
        :param pulumi.Input[str] protocol_type: The protocol type of the vepfs file system.
        :param pulumi.Input[str] region_id: The id of the region.
        :param pulumi.Input[str] status: The status of the vepfs file system.
        :param pulumi.Input[str] stop_service_time: The stop service time of the vepfs file system.
        :param pulumi.Input[str] store_type: The store type of the vepfs file system. Valid values: `Advance_100`, `Performance`, `Intelligent_Computing`.
        :param pulumi.Input[str] store_type_cn: The store type cn name of the vepfs file system.
        :param pulumi.Input[str] subnet_id: The subnet id of the vepfs file system.
        :param pulumi.Input[Sequence[pulumi.Input['FileSystemTagArgs']]] tags: Tags.
        :param pulumi.Input[str] version: The version info of the vepfs file system.
        :param pulumi.Input[str] zone_id: The id of the zone.
        :param pulumi.Input[str] zone_name: The name of the zone.
        """
        if account_id is not None:
            pulumi.set(__self__, "account_id", account_id)
        if bandwidth is not None:
            pulumi.set(__self__, "bandwidth", bandwidth)
        if capacity is not None:
            pulumi.set(__self__, "capacity", capacity)
        if charge_status is not None:
            pulumi.set(__self__, "charge_status", charge_status)
        if charge_type is not None:
            pulumi.set(__self__, "charge_type", charge_type)
        if create_time is not None:
            pulumi.set(__self__, "create_time", create_time)
        if description is not None:
            pulumi.set(__self__, "description", description)
        if enable_restripe is not None:
            pulumi.set(__self__, "enable_restripe", enable_restripe)
        if expire_time is not None:
            pulumi.set(__self__, "expire_time", expire_time)
        if file_system_name is not None:
            pulumi.set(__self__, "file_system_name", file_system_name)
        if file_system_type is not None:
            pulumi.set(__self__, "file_system_type", file_system_type)
        if free_time is not None:
            pulumi.set(__self__, "free_time", free_time)
        if last_modify_time is not None:
            pulumi.set(__self__, "last_modify_time", last_modify_time)
        if project is not None:
            pulumi.set(__self__, "project", project)
        if protocol_type is not None:
            pulumi.set(__self__, "protocol_type", protocol_type)
        if region_id is not None:
            pulumi.set(__self__, "region_id", region_id)
        if status is not None:
            pulumi.set(__self__, "status", status)
        if stop_service_time is not None:
            pulumi.set(__self__, "stop_service_time", stop_service_time)
        if store_type is not None:
            pulumi.set(__self__, "store_type", store_type)
        if store_type_cn is not None:
            pulumi.set(__self__, "store_type_cn", store_type_cn)
        if subnet_id is not None:
            pulumi.set(__self__, "subnet_id", subnet_id)
        if tags is not None:
            pulumi.set(__self__, "tags", tags)
        if version is not None:
            pulumi.set(__self__, "version", version)
        if zone_id is not None:
            pulumi.set(__self__, "zone_id", zone_id)
        if zone_name is not None:
            pulumi.set(__self__, "zone_name", zone_name)

    @property
    @pulumi.getter(name="accountId")
    def account_id(self) -> Optional[pulumi.Input[str]]:
        """
        The id of the account.
        """
        return pulumi.get(self, "account_id")

    @account_id.setter
    def account_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "account_id", value)

    @property
    @pulumi.getter
    def bandwidth(self) -> Optional[pulumi.Input[int]]:
        """
        The bandwidth info of the vepfs file system.
        """
        return pulumi.get(self, "bandwidth")

    @bandwidth.setter
    def bandwidth(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "bandwidth", value)

    @property
    @pulumi.getter
    def capacity(self) -> Optional[pulumi.Input[int]]:
        """
        The capacity of the vepfs file system.
        """
        return pulumi.get(self, "capacity")

    @capacity.setter
    def capacity(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "capacity", value)

    @property
    @pulumi.getter(name="chargeStatus")
    def charge_status(self) -> Optional[pulumi.Input[str]]:
        """
        The charge status of the vepfs file system.
        """
        return pulumi.get(self, "charge_status")

    @charge_status.setter
    def charge_status(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "charge_status", value)

    @property
    @pulumi.getter(name="chargeType")
    def charge_type(self) -> Optional[pulumi.Input[str]]:
        """
        The charge type of the vepfs file system.
        """
        return pulumi.get(self, "charge_type")

    @charge_type.setter
    def charge_type(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "charge_type", value)

    @property
    @pulumi.getter(name="createTime")
    def create_time(self) -> Optional[pulumi.Input[str]]:
        """
        The create time of the vepfs file system.
        """
        return pulumi.get(self, "create_time")

    @create_time.setter
    def create_time(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "create_time", value)

    @property
    @pulumi.getter
    def description(self) -> Optional[pulumi.Input[str]]:
        """
        The description info of the vepfs file system.
        """
        return pulumi.get(self, "description")

    @description.setter
    def description(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "description", value)

    @property
    @pulumi.getter(name="enableRestripe")
    def enable_restripe(self) -> Optional[pulumi.Input[bool]]:
        """
        Whether to enable data balance after capacity expansion. This filed is valid only when expanding capacity.
        """
        return pulumi.get(self, "enable_restripe")

    @enable_restripe.setter
    def enable_restripe(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "enable_restripe", value)

    @property
    @pulumi.getter(name="expireTime")
    def expire_time(self) -> Optional[pulumi.Input[str]]:
        """
        The expire time of the vepfs file system.
        """
        return pulumi.get(self, "expire_time")

    @expire_time.setter
    def expire_time(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "expire_time", value)

    @property
    @pulumi.getter(name="fileSystemName")
    def file_system_name(self) -> Optional[pulumi.Input[str]]:
        """
        The name of the vepfs file system.
        """
        return pulumi.get(self, "file_system_name")

    @file_system_name.setter
    def file_system_name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "file_system_name", value)

    @property
    @pulumi.getter(name="fileSystemType")
    def file_system_type(self) -> Optional[pulumi.Input[str]]:
        """
        The type of the vepfs file system.
        """
        return pulumi.get(self, "file_system_type")

    @file_system_type.setter
    def file_system_type(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "file_system_type", value)

    @property
    @pulumi.getter(name="freeTime")
    def free_time(self) -> Optional[pulumi.Input[str]]:
        """
        The free time of the vepfs file system.
        """
        return pulumi.get(self, "free_time")

    @free_time.setter
    def free_time(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "free_time", value)

    @property
    @pulumi.getter(name="lastModifyTime")
    def last_modify_time(self) -> Optional[pulumi.Input[str]]:
        """
        The last modify time of the vepfs file system.
        """
        return pulumi.get(self, "last_modify_time")

    @last_modify_time.setter
    def last_modify_time(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "last_modify_time", value)

    @property
    @pulumi.getter
    def project(self) -> Optional[pulumi.Input[str]]:
        """
        The project of the vepfs file system.
        """
        return pulumi.get(self, "project")

    @project.setter
    def project(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "project", value)

    @property
    @pulumi.getter(name="protocolType")
    def protocol_type(self) -> Optional[pulumi.Input[str]]:
        """
        The protocol type of the vepfs file system.
        """
        return pulumi.get(self, "protocol_type")

    @protocol_type.setter
    def protocol_type(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "protocol_type", value)

    @property
    @pulumi.getter(name="regionId")
    def region_id(self) -> Optional[pulumi.Input[str]]:
        """
        The id of the region.
        """
        return pulumi.get(self, "region_id")

    @region_id.setter
    def region_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "region_id", value)

    @property
    @pulumi.getter
    def status(self) -> Optional[pulumi.Input[str]]:
        """
        The status of the vepfs file system.
        """
        return pulumi.get(self, "status")

    @status.setter
    def status(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "status", value)

    @property
    @pulumi.getter(name="stopServiceTime")
    def stop_service_time(self) -> Optional[pulumi.Input[str]]:
        """
        The stop service time of the vepfs file system.
        """
        return pulumi.get(self, "stop_service_time")

    @stop_service_time.setter
    def stop_service_time(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "stop_service_time", value)

    @property
    @pulumi.getter(name="storeType")
    def store_type(self) -> Optional[pulumi.Input[str]]:
        """
        The store type of the vepfs file system. Valid values: `Advance_100`, `Performance`, `Intelligent_Computing`.
        """
        return pulumi.get(self, "store_type")

    @store_type.setter
    def store_type(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "store_type", value)

    @property
    @pulumi.getter(name="storeTypeCn")
    def store_type_cn(self) -> Optional[pulumi.Input[str]]:
        """
        The store type cn name of the vepfs file system.
        """
        return pulumi.get(self, "store_type_cn")

    @store_type_cn.setter
    def store_type_cn(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "store_type_cn", value)

    @property
    @pulumi.getter(name="subnetId")
    def subnet_id(self) -> Optional[pulumi.Input[str]]:
        """
        The subnet id of the vepfs file system.
        """
        return pulumi.get(self, "subnet_id")

    @subnet_id.setter
    def subnet_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "subnet_id", value)

    @property
    @pulumi.getter
    def tags(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['FileSystemTagArgs']]]]:
        """
        Tags.
        """
        return pulumi.get(self, "tags")

    @tags.setter
    def tags(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['FileSystemTagArgs']]]]):
        pulumi.set(self, "tags", value)

    @property
    @pulumi.getter
    def version(self) -> Optional[pulumi.Input[str]]:
        """
        The version info of the vepfs file system.
        """
        return pulumi.get(self, "version")

    @version.setter
    def version(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "version", value)

    @property
    @pulumi.getter(name="zoneId")
    def zone_id(self) -> Optional[pulumi.Input[str]]:
        """
        The id of the zone.
        """
        return pulumi.get(self, "zone_id")

    @zone_id.setter
    def zone_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "zone_id", value)

    @property
    @pulumi.getter(name="zoneName")
    def zone_name(self) -> Optional[pulumi.Input[str]]:
        """
        The name of the zone.
        """
        return pulumi.get(self, "zone_name")

    @zone_name.setter
    def zone_name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "zone_name", value)


class FileSystem(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 capacity: Optional[pulumi.Input[int]] = None,
                 description: Optional[pulumi.Input[str]] = None,
                 enable_restripe: Optional[pulumi.Input[bool]] = None,
                 file_system_name: Optional[pulumi.Input[str]] = None,
                 project: Optional[pulumi.Input[str]] = None,
                 store_type: Optional[pulumi.Input[str]] = None,
                 subnet_id: Optional[pulumi.Input[str]] = None,
                 tags: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['FileSystemTagArgs']]]]] = None,
                 __props__=None):
        """
        Provides a resource to manage vepfs file system
        ## Example Usage

        ```python
        import pulumi
        import pulumi_volcengine as volcengine

        foo_vpc = volcengine.vpc.Vpc("fooVpc",
            vpc_name="acc-test-vpc",
            cidr_block="172.16.0.0/16")
        foo_subnet = volcengine.vpc.Subnet("fooSubnet",
            subnet_name="acc-test-subnet",
            cidr_block="172.16.0.0/24",
            zone_id="cn-beijing-a",
            vpc_id=foo_vpc.id)
        foo_file_system = volcengine.vepfs.FileSystem("fooFileSystem",
            file_system_name="acc-test-file-system",
            subnet_id=foo_subnet.id,
            store_type="Advance_100",
            description="tf-test",
            capacity=12,
            project="default",
            enable_restripe=False,
            tags=[volcengine.vepfs.FileSystemTagArgs(
                key="k1",
                value="v1",
            )])
        ```

        ## Import

        VepfsFileSystem can be imported using the id, e.g.

        ```sh
        $ pulumi import volcengine:vepfs/fileSystem:FileSystem default resource_id
        ```

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[int] capacity: The capacity of the vepfs file system.
        :param pulumi.Input[str] description: The description info of the vepfs file system.
        :param pulumi.Input[bool] enable_restripe: Whether to enable data balance after capacity expansion. This filed is valid only when expanding capacity.
        :param pulumi.Input[str] file_system_name: The name of the vepfs file system.
        :param pulumi.Input[str] project: The project of the vepfs file system.
        :param pulumi.Input[str] store_type: The store type of the vepfs file system. Valid values: `Advance_100`, `Performance`, `Intelligent_Computing`.
        :param pulumi.Input[str] subnet_id: The subnet id of the vepfs file system.
        :param pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['FileSystemTagArgs']]]] tags: Tags.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: FileSystemArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Provides a resource to manage vepfs file system
        ## Example Usage

        ```python
        import pulumi
        import pulumi_volcengine as volcengine

        foo_vpc = volcengine.vpc.Vpc("fooVpc",
            vpc_name="acc-test-vpc",
            cidr_block="172.16.0.0/16")
        foo_subnet = volcengine.vpc.Subnet("fooSubnet",
            subnet_name="acc-test-subnet",
            cidr_block="172.16.0.0/24",
            zone_id="cn-beijing-a",
            vpc_id=foo_vpc.id)
        foo_file_system = volcengine.vepfs.FileSystem("fooFileSystem",
            file_system_name="acc-test-file-system",
            subnet_id=foo_subnet.id,
            store_type="Advance_100",
            description="tf-test",
            capacity=12,
            project="default",
            enable_restripe=False,
            tags=[volcengine.vepfs.FileSystemTagArgs(
                key="k1",
                value="v1",
            )])
        ```

        ## Import

        VepfsFileSystem can be imported using the id, e.g.

        ```sh
        $ pulumi import volcengine:vepfs/fileSystem:FileSystem default resource_id
        ```

        :param str resource_name: The name of the resource.
        :param FileSystemArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(FileSystemArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 capacity: Optional[pulumi.Input[int]] = None,
                 description: Optional[pulumi.Input[str]] = None,
                 enable_restripe: Optional[pulumi.Input[bool]] = None,
                 file_system_name: Optional[pulumi.Input[str]] = None,
                 project: Optional[pulumi.Input[str]] = None,
                 store_type: Optional[pulumi.Input[str]] = None,
                 subnet_id: Optional[pulumi.Input[str]] = None,
                 tags: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['FileSystemTagArgs']]]]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = FileSystemArgs.__new__(FileSystemArgs)

            if capacity is None and not opts.urn:
                raise TypeError("Missing required property 'capacity'")
            __props__.__dict__["capacity"] = capacity
            __props__.__dict__["description"] = description
            __props__.__dict__["enable_restripe"] = enable_restripe
            if file_system_name is None and not opts.urn:
                raise TypeError("Missing required property 'file_system_name'")
            __props__.__dict__["file_system_name"] = file_system_name
            __props__.__dict__["project"] = project
            if store_type is None and not opts.urn:
                raise TypeError("Missing required property 'store_type'")
            __props__.__dict__["store_type"] = store_type
            if subnet_id is None and not opts.urn:
                raise TypeError("Missing required property 'subnet_id'")
            __props__.__dict__["subnet_id"] = subnet_id
            __props__.__dict__["tags"] = tags
            __props__.__dict__["account_id"] = None
            __props__.__dict__["bandwidth"] = None
            __props__.__dict__["charge_status"] = None
            __props__.__dict__["charge_type"] = None
            __props__.__dict__["create_time"] = None
            __props__.__dict__["expire_time"] = None
            __props__.__dict__["file_system_type"] = None
            __props__.__dict__["free_time"] = None
            __props__.__dict__["last_modify_time"] = None
            __props__.__dict__["protocol_type"] = None
            __props__.__dict__["region_id"] = None
            __props__.__dict__["status"] = None
            __props__.__dict__["stop_service_time"] = None
            __props__.__dict__["store_type_cn"] = None
            __props__.__dict__["version"] = None
            __props__.__dict__["zone_id"] = None
            __props__.__dict__["zone_name"] = None
        super(FileSystem, __self__).__init__(
            'volcengine:vepfs/fileSystem:FileSystem',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            account_id: Optional[pulumi.Input[str]] = None,
            bandwidth: Optional[pulumi.Input[int]] = None,
            capacity: Optional[pulumi.Input[int]] = None,
            charge_status: Optional[pulumi.Input[str]] = None,
            charge_type: Optional[pulumi.Input[str]] = None,
            create_time: Optional[pulumi.Input[str]] = None,
            description: Optional[pulumi.Input[str]] = None,
            enable_restripe: Optional[pulumi.Input[bool]] = None,
            expire_time: Optional[pulumi.Input[str]] = None,
            file_system_name: Optional[pulumi.Input[str]] = None,
            file_system_type: Optional[pulumi.Input[str]] = None,
            free_time: Optional[pulumi.Input[str]] = None,
            last_modify_time: Optional[pulumi.Input[str]] = None,
            project: Optional[pulumi.Input[str]] = None,
            protocol_type: Optional[pulumi.Input[str]] = None,
            region_id: Optional[pulumi.Input[str]] = None,
            status: Optional[pulumi.Input[str]] = None,
            stop_service_time: Optional[pulumi.Input[str]] = None,
            store_type: Optional[pulumi.Input[str]] = None,
            store_type_cn: Optional[pulumi.Input[str]] = None,
            subnet_id: Optional[pulumi.Input[str]] = None,
            tags: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['FileSystemTagArgs']]]]] = None,
            version: Optional[pulumi.Input[str]] = None,
            zone_id: Optional[pulumi.Input[str]] = None,
            zone_name: Optional[pulumi.Input[str]] = None) -> 'FileSystem':
        """
        Get an existing FileSystem resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] account_id: The id of the account.
        :param pulumi.Input[int] bandwidth: The bandwidth info of the vepfs file system.
        :param pulumi.Input[int] capacity: The capacity of the vepfs file system.
        :param pulumi.Input[str] charge_status: The charge status of the vepfs file system.
        :param pulumi.Input[str] charge_type: The charge type of the vepfs file system.
        :param pulumi.Input[str] create_time: The create time of the vepfs file system.
        :param pulumi.Input[str] description: The description info of the vepfs file system.
        :param pulumi.Input[bool] enable_restripe: Whether to enable data balance after capacity expansion. This filed is valid only when expanding capacity.
        :param pulumi.Input[str] expire_time: The expire time of the vepfs file system.
        :param pulumi.Input[str] file_system_name: The name of the vepfs file system.
        :param pulumi.Input[str] file_system_type: The type of the vepfs file system.
        :param pulumi.Input[str] free_time: The free time of the vepfs file system.
        :param pulumi.Input[str] last_modify_time: The last modify time of the vepfs file system.
        :param pulumi.Input[str] project: The project of the vepfs file system.
        :param pulumi.Input[str] protocol_type: The protocol type of the vepfs file system.
        :param pulumi.Input[str] region_id: The id of the region.
        :param pulumi.Input[str] status: The status of the vepfs file system.
        :param pulumi.Input[str] stop_service_time: The stop service time of the vepfs file system.
        :param pulumi.Input[str] store_type: The store type of the vepfs file system. Valid values: `Advance_100`, `Performance`, `Intelligent_Computing`.
        :param pulumi.Input[str] store_type_cn: The store type cn name of the vepfs file system.
        :param pulumi.Input[str] subnet_id: The subnet id of the vepfs file system.
        :param pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['FileSystemTagArgs']]]] tags: Tags.
        :param pulumi.Input[str] version: The version info of the vepfs file system.
        :param pulumi.Input[str] zone_id: The id of the zone.
        :param pulumi.Input[str] zone_name: The name of the zone.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _FileSystemState.__new__(_FileSystemState)

        __props__.__dict__["account_id"] = account_id
        __props__.__dict__["bandwidth"] = bandwidth
        __props__.__dict__["capacity"] = capacity
        __props__.__dict__["charge_status"] = charge_status
        __props__.__dict__["charge_type"] = charge_type
        __props__.__dict__["create_time"] = create_time
        __props__.__dict__["description"] = description
        __props__.__dict__["enable_restripe"] = enable_restripe
        __props__.__dict__["expire_time"] = expire_time
        __props__.__dict__["file_system_name"] = file_system_name
        __props__.__dict__["file_system_type"] = file_system_type
        __props__.__dict__["free_time"] = free_time
        __props__.__dict__["last_modify_time"] = last_modify_time
        __props__.__dict__["project"] = project
        __props__.__dict__["protocol_type"] = protocol_type
        __props__.__dict__["region_id"] = region_id
        __props__.__dict__["status"] = status
        __props__.__dict__["stop_service_time"] = stop_service_time
        __props__.__dict__["store_type"] = store_type
        __props__.__dict__["store_type_cn"] = store_type_cn
        __props__.__dict__["subnet_id"] = subnet_id
        __props__.__dict__["tags"] = tags
        __props__.__dict__["version"] = version
        __props__.__dict__["zone_id"] = zone_id
        __props__.__dict__["zone_name"] = zone_name
        return FileSystem(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="accountId")
    def account_id(self) -> pulumi.Output[str]:
        """
        The id of the account.
        """
        return pulumi.get(self, "account_id")

    @property
    @pulumi.getter
    def bandwidth(self) -> pulumi.Output[int]:
        """
        The bandwidth info of the vepfs file system.
        """
        return pulumi.get(self, "bandwidth")

    @property
    @pulumi.getter
    def capacity(self) -> pulumi.Output[int]:
        """
        The capacity of the vepfs file system.
        """
        return pulumi.get(self, "capacity")

    @property
    @pulumi.getter(name="chargeStatus")
    def charge_status(self) -> pulumi.Output[str]:
        """
        The charge status of the vepfs file system.
        """
        return pulumi.get(self, "charge_status")

    @property
    @pulumi.getter(name="chargeType")
    def charge_type(self) -> pulumi.Output[str]:
        """
        The charge type of the vepfs file system.
        """
        return pulumi.get(self, "charge_type")

    @property
    @pulumi.getter(name="createTime")
    def create_time(self) -> pulumi.Output[str]:
        """
        The create time of the vepfs file system.
        """
        return pulumi.get(self, "create_time")

    @property
    @pulumi.getter
    def description(self) -> pulumi.Output[Optional[str]]:
        """
        The description info of the vepfs file system.
        """
        return pulumi.get(self, "description")

    @property
    @pulumi.getter(name="enableRestripe")
    def enable_restripe(self) -> pulumi.Output[Optional[bool]]:
        """
        Whether to enable data balance after capacity expansion. This filed is valid only when expanding capacity.
        """
        return pulumi.get(self, "enable_restripe")

    @property
    @pulumi.getter(name="expireTime")
    def expire_time(self) -> pulumi.Output[str]:
        """
        The expire time of the vepfs file system.
        """
        return pulumi.get(self, "expire_time")

    @property
    @pulumi.getter(name="fileSystemName")
    def file_system_name(self) -> pulumi.Output[str]:
        """
        The name of the vepfs file system.
        """
        return pulumi.get(self, "file_system_name")

    @property
    @pulumi.getter(name="fileSystemType")
    def file_system_type(self) -> pulumi.Output[str]:
        """
        The type of the vepfs file system.
        """
        return pulumi.get(self, "file_system_type")

    @property
    @pulumi.getter(name="freeTime")
    def free_time(self) -> pulumi.Output[str]:
        """
        The free time of the vepfs file system.
        """
        return pulumi.get(self, "free_time")

    @property
    @pulumi.getter(name="lastModifyTime")
    def last_modify_time(self) -> pulumi.Output[str]:
        """
        The last modify time of the vepfs file system.
        """
        return pulumi.get(self, "last_modify_time")

    @property
    @pulumi.getter
    def project(self) -> pulumi.Output[str]:
        """
        The project of the vepfs file system.
        """
        return pulumi.get(self, "project")

    @property
    @pulumi.getter(name="protocolType")
    def protocol_type(self) -> pulumi.Output[str]:
        """
        The protocol type of the vepfs file system.
        """
        return pulumi.get(self, "protocol_type")

    @property
    @pulumi.getter(name="regionId")
    def region_id(self) -> pulumi.Output[str]:
        """
        The id of the region.
        """
        return pulumi.get(self, "region_id")

    @property
    @pulumi.getter
    def status(self) -> pulumi.Output[str]:
        """
        The status of the vepfs file system.
        """
        return pulumi.get(self, "status")

    @property
    @pulumi.getter(name="stopServiceTime")
    def stop_service_time(self) -> pulumi.Output[str]:
        """
        The stop service time of the vepfs file system.
        """
        return pulumi.get(self, "stop_service_time")

    @property
    @pulumi.getter(name="storeType")
    def store_type(self) -> pulumi.Output[str]:
        """
        The store type of the vepfs file system. Valid values: `Advance_100`, `Performance`, `Intelligent_Computing`.
        """
        return pulumi.get(self, "store_type")

    @property
    @pulumi.getter(name="storeTypeCn")
    def store_type_cn(self) -> pulumi.Output[str]:
        """
        The store type cn name of the vepfs file system.
        """
        return pulumi.get(self, "store_type_cn")

    @property
    @pulumi.getter(name="subnetId")
    def subnet_id(self) -> pulumi.Output[str]:
        """
        The subnet id of the vepfs file system.
        """
        return pulumi.get(self, "subnet_id")

    @property
    @pulumi.getter
    def tags(self) -> pulumi.Output[Optional[Sequence['outputs.FileSystemTag']]]:
        """
        Tags.
        """
        return pulumi.get(self, "tags")

    @property
    @pulumi.getter
    def version(self) -> pulumi.Output[str]:
        """
        The version info of the vepfs file system.
        """
        return pulumi.get(self, "version")

    @property
    @pulumi.getter(name="zoneId")
    def zone_id(self) -> pulumi.Output[str]:
        """
        The id of the zone.
        """
        return pulumi.get(self, "zone_id")

    @property
    @pulumi.getter(name="zoneName")
    def zone_name(self) -> pulumi.Output[str]:
        """
        The name of the zone.
        """
        return pulumi.get(self, "zone_name")

